.386
.model flat, stdcall
option casemap :none

m2m MACRO M1, M2
push M2
pop  M1
ENDM

FUNC MACRO parameters:VARARG
invoke parameters
EXITM <eax>
ENDM

include \MASM32\INCLUDE\windows.inc
include \MASM32\INCLUDE\kernel32.inc
include \MASM32\INCLUDE\user32.inc
include \MASM32\INCLUDE\masm32.inc
include \MASM32\INCLUDE\gdi32.inc
include \MASM32\INCLUDE\oleaut32.inc
includelib \MASM32\LIB\kernel32.lib
includelib \MASM32\LIB\user32.lib
includelib \MASM32\LIB\masm32.lib
includelib \MASM32\LIB\gdi32.lib
includelib \MASM32\LIB\oleaut32.lib

include \masm32\include\dialogs.inc


.data
about db "         %track%",13,10,13,10
	db " : Winamp, Light Alloy     api Winamp",13,10
	db "      R&Q 1070  ",0
pluginname db "Winamp2RnQ v2.1",0
dot db '. ',0
cuttext db ' - Winamp',0
lacuttext db ' - Light Alloy',0
winampclass  db 'Winamp v1.x',0
laclass db 'LightAlloyFront',0
configname db 'wa2rnq.dat',0
track db '%track%',0
hWinamp dd 0
player dd 0 ; 1 - WA, 2 - LA

.data?
hInstance dd ?
hDll dd ?
hRoaster dd ?
buffer db 1024 dup(?)
songbuffer db 512 dup (?)
wbuffer db 512 dup (?)

include plugin.inc
include callexec.inc

Preferences proto
Replace proto
TimerProc proto :DWORD,:DWORD,:DWORD,:DWORD



.code

LibMain proc hInstDLL:DWORD, reason:DWORD, unused:DWORD
.if reason == DLL_PROCESS_ATTACH
	m2m hDll,hInstDLL
	xor eax,eax
	invoke GetModuleHandle,eax
	mov hInstance,eax
	xor eax,eax
	inc eax
	ret
.endif
ret
LibMain Endp

pluginFun proc data:DWORD
	mov eax,data
	xor ecx,ecx
	mov cl, [eax+4]
	.if ecx == PM_EVENT
		mov cl, [eax+5]
		.if ecx == PE_INITIALIZE
			mov ecx, [eax+6]
			mov callback, ecx

			mov byte ptr buffer, PM_GET
			mov byte ptr buffer+1, PG_WINDOW			
			mov byte ptr buffer+2, PW_ROASTER
			invoke callStr,addr buffer,3
			mov eax,[eax+5]
			mov hRoaster,eax

			invoke TimerProc,hRoaster,WM_TIMER,666,0
			invoke SetTimer,hRoaster,666,1000,addr TimerProc
			
			mov byte ptr buffer, PM_DATA
			invoke lstrlen, addr pluginname
			mov dword ptr buffer+1,eax
			push eax
			invoke lstrcpy, offset buffer+5, addr pluginname
			add eax,dword ptr buffer+1
			mov dword ptr [eax],4
			pop eax
			add eax,9
			invoke str2comm, addr buffer,eax
			ret
		.elseif ecx == PE_FINALIZE
			invoke KillTimer,hRoaster,666
		.elseif ecx == PE_PREFERENCES
			call Preferences
		.elseif ecx == PE_XSTATUSMSG_SENT
			invoke Replace
			invoke str2comm, addr buffer,eax
			ret			
		.endif
	.endif
	xor eax,eax
ret
pluginFun endp

GetSong proc
	.if player == 1
		invoke GetWindowText,hWinamp,addr buffer,255
		invoke lstrlen, addr buffer
		invoke SBMBinSearch,0,addr buffer,eax,addr cuttext,9
		cmp eax, -1
		je error
		add eax, offset buffer
		mov byte ptr [eax],0
		invoke lstrlen, addr buffer
		invoke SBMBinSearch,0,addr buffer,eax,addr dot,2
		add eax,2
		add eax, offset buffer
		invoke lstrcpy, addr songbuffer, eax
	.elseif player == 2
		invoke GetWindowText,hWinamp,addr songbuffer,255
		invoke lstrlen, addr songbuffer
		invoke SBMBinSearch,0,addr songbuffer,eax,addr lacuttext,14
		cmp eax, -1
		je error
		add eax, offset songbuffer
		mov byte ptr [eax],0
	.endif
	invoke MultiByteToWideChar,CP_ACP,0,addr songbuffer,-1,addr buffer,256
	invoke WideCharToMultiByte,65001,0,addr buffer,-1,addr songbuffer,512,0,0

ret
error:
pop eax
mov byte ptr songbuffer,0
ret
GetSong endp

Replace proc uses esi edi
	add eax,11
	mov esi,eax
	mov byte ptr buffer,PM_DATA
	mov edi,[esi]
	add edi,4
	invoke MemCopy,esi,addr buffer+1,edi
	add esi,edi
	mov eax,[esi]
	add esi,4
	push eax
	invoke MemCopy,esi,addr wbuffer,eax
	pop eax
	add eax,offset wbuffer
	mov byte ptr [eax],0
	add edi,5
	mov esi,offset buffer
	add esi,edi
	invoke szRep,addr wbuffer,esi,addr track, addr songbuffer
	invoke lstrlen,esi
	mov [esi-4],eax
	add eax,edi
	ret
Replace endp

TimerProc proc hWnd:DWORD, uMsg:DWORD, idEvent:DWORD, dwTime:DWORD
	invoke FindWindow,addr laclass,0
	mov hWinamp,eax
	.if eax == 0
		invoke FindWindow,addr winampclass,eax
		.if eax != 0
			mov player, 1
		.endif
	.else
		mov player, 2
	.endif
	mov hWinamp,eax
	.if eax == 0
		mov player,eax
		mov byte ptr songbuffer,al
	.else
		invoke GetSong
	.endif
exit:
ret
TimerProc endp

Preferences proc
	invoke MessageBox,0,addr about,addr pluginname,MB_ICONINFORMATION
ret
Preferences endp
End LibMain